(* ::Package:: *)

(* ::Section:: *)
(*Define input value and simulation time*)


OFF = 0.1;    
ON = 0.9;
input = {{OFF,ON}, {OFF,ON}, {OFF,ON}, {OFF,ON}};
time = 10*60*60;


(* ::Section:: *)
(*Simulation*)


SIMsquareroot=Table[
gatesys={
seesawOR[10,1,{21,27},{23}],
seesawAND[53,5,{18,22},{6}],
seesawOR[34,18,{28,33,37},{53}],
seesawAND[36,21,{29,35,38},{10}],
seesawOR[39,22,{29,31},{53}],
seesawAND[40,27,{30,28},{10}],
seesawOR[41,28,{46,48},{34,40}],
seesawAND[42,29,{45,47},{36,39}],
seesawOR[43,30,{33,38},{40}],
seesawAND[44,31,{35,37},{39}],
seesawOR[20,8,{35,38},{25}],
seesawAND[26,13,{33,37},{24}],
inputfanout[33,49,{34,43,26}],
inputfanout[35,50,{36,44,20}],
inputfanout[37,51,{34,44,26}],
inputfanout[38,52,{36,43,20}],
reporter[6,5],
reporter[23,1],
reporter[24,13],
reporter[25,8],
conc[w[45,42],(1-x1)*c],
conc[w[46,41],x1*c],
conc[w[47,42],(1-x2)*c],
conc[w[48,41],x2*c],
conc[w[49,33],(1-x3)*c],
conc[w[50,35],x3*c],
conc[w[51,37],(1-x4)*c],
conc[w[52,38],x4*c],
conc[W,56*c],
conc[G,56*c],
conc[TH,1.1*12.6*c]
};
sol=gatesysToNDSolve[gatesys,time]//ReleaseHold//Flatten;
{Fluor[6][t]/c/.sol,Fluor[23][t]/c/.sol,Fluor[24][t]/c/.sol,Fluor[25][t]/c/.sol},
{x1,input[[1]]},{x2,input[[2]]},{x3,input[[3]]},{x4,input[[4]]}
];


(* ::Section:: *)
(*Plot*)


Plot[SIMsquareroot,{t,0,time},Frame->True,FrameLabel->{"Time (hours)","Output"},LabelStyle->Directive[FontSize->24,FontFamily->"Helvetica"],FrameTicks->{{{{0,0},{0.2,0.2},{0.4,0.4},{0.6,0.6},{0.8,0.8},{1,1}},{{0,""},{0.2,""},{0.4,""},{0.6,""},{0.8,""},{1,""}}},{{{0,0},{7200,2},{14400,4},{21600,6},{28800,8},{36000,10}},{{0,""},{7200,""},{14400,""},{21600,""},{28800,""},{36000,""}}}},PlotStyle->{{RGBColor[62/255,62/255,62/255],Thick,Dotted},{RGBColor[62/255,62/255,62/255],Thick},{RGBColor[189/255,79/255,76/255],Thick,Dotted},{RGBColor[189/255,79/255,76/255],Thick}},PlotRange->{{0,time},{0,1.05}},AspectRatio->1/1.32,ImageSize->400]
